/*! Copyright 2013 Amazon Digital Services, Inc. All rights reserved. */
APICallHandler=(function(){var c=function(o,l,n){var q=o;var p=l;var k=n;var m="APICall";this["getHandledType"]=function(){return m};this["handleRequest"]=function(t){var P=$.Deferred();if(!(t instanceof Request)){console.log("APICallHandler: handleRequest: input was not of type Request");var E=new Result(constants.NativeCallResultCode.ERROR,{});P.resolve(E)}else{var s=t.getType();var Q=t.getParams();console.log("APICallHandler: handleRequest: message is: "+JSON.stringify(Q));var v=""+Q[constants.ServiceActionCode.ACTION_CODE_KEY];var F={};switch(v){case constants.ServiceActionCode.AUTHORIZE_SESSION:q.onInitialize();q.getInitializationPromise().always(function(){var R={};R[constants.BindingKeys.AUTHORIZE_RESULT_BUNDLE_KEY]=constants.AuthorizeKeys.AUTHORIZED;var S=constants.NativeCallResultCode.SUCCESS;var T=new Result(S,R);P.resolve(T)});break;case constants.ServiceActionCode.START_SESSION:p.startSession(Q[constants.BindingKeys.REQUEST_TIMESTAMP]);q.startSession();var J=new Result(constants.NativeCallResultCode.SUCCESS,{});P.resolve(J);break;case constants.ServiceActionCode.STOP_SESSION:p.stopSession(Q[constants.BindingKeys.REQUEST_TIMESTAMP]);var J=new Result(constants.NativeCallResultCode.SUCCESS,{});P.resolve(J);break;case constants.ServiceActionCode.SHOW_SIGN_IN_PAGE:q.showSignInPage();var J=new Result(constants.NativeCallResultCode.SUCCESS,{});P.resolve(J);break;case constants.ServiceActionCode.SHOW_TOS_PAGE:q.showOverlay(constants.OverlayActionCode.SHOW_TERMS_OF_SERVICE);var J=new Result(constants.NativeCallResultCode.SUCCESS,{});P.resolve(J);break;case constants.ServiceActionCode.SET_OPT_IN:var u=Q[constants.NativeCallKeys.HAS_OPTED_IN];q.setOptIn(u);J=new Result(constants.NativeCallResultCode.SUCCESS,{});P.resolve(J);break;case constants.ServiceActionCode.AUTHENTICATE:q.authenticate();var J=new Result(constants.NativeCallResultCode.SUCCESS,{});P.resolve(J);break;case constants.ServiceActionCode.UPDATE_COUNTRY_OF_RESIDENCE:q.updateCOR(t.getParams()[constants.BindingKeys.COUNTRY_OF_RESIDENCE]);var J=new Result(constants.NativeCallResultCode.SUCCESS,{});P.resolve(J);break;case constants.ServiceActionCode.IS_WHISPERSYNC_ENABLED:k.getGuestMode().always(function(R){k.isKindle().always(function(T){var S=$.Deferred();if(T){k.isKindleWhispersyncSettingEnabled().always(function(U){S.resolve(U)})}else{k.getWhispersyncEnabledUserSetting().always(function(U){S.resolve(U)})}S.always(function(V){var U={};if(R||!V){U[constants.BindingKeys.WHISPERSYNC_ENABLED]=false}else{U[constants.BindingKeys.WHISPERSYNC_ENABLED]=true}var W=new Result(constants.NativeCallResultCode.SUCCESS,U);P.resolve(W)})})});break;case constants.ServiceActionCode.SHOW_OVERLAY_ACHIEVEMENTS:var O={};O[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_ACHIEVEMENTS;hostinterface.showOverlay(JSON.stringify(O));break;case constants.ServiceActionCode.SHOW_OVERLAY_PROFILE:var O={};O[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_PROFILE;hostinterface.showOverlay(JSON.stringify(O));break;case constants.ServiceActionCode.SHOW_OVERLAY_LEADERBOARDS:var O={};O[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_LEADERBOARDS;hostinterface.showOverlay(JSON.stringify(O));break;case constants.ServiceActionCode.SHOW_OVERLAY_RANKS:var O={};O[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_LEADERBOARD_RANKS;O[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=t.getParams()[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY];hostinterface.showOverlay(JSON.stringify(O));break;case constants.ServiceActionCode.SHOW_GAME_CIRCLE:case constants.ServiceActionCode.SHOW_OVERLAY_SUMMARY:var O={};O[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_SUMMARY;hostinterface.showOverlay(JSON.stringify(O));var J=new Result(constants.NativeCallResultCode.SUCCESS,{});P.resolve(J);break;case constants.ServiceActionCode.HANDLE_TOAST_CLICK:var F={};var D=t.getParams()[constants.ToastKeys.ACTION_MAPPINGS_KEY];var N=t.getParams()[constants.ToastKeys.TOAST_CLICK_DATA_KEY];var M=ServiceFactory.getRequestFactory().createToastClickRequest(D,N);ServiceFactory.getRequestRouter().handleRequest(M).always(function(R){P.resolve({})});break;case constants.ServiceActionCode.HANDLE_TOAST_DISPLAY_METRIC:var F={};var z=t.getParams()[constants.ToastKeys.TOAST_REQUEST_DISPLAYED];var C=ServiceFactory.getRequestFactory().createToastMetricRequest(z);ServiceFactory.getRequestRouter().handleRequest(C).always(function(R){P.resolve({})});break;case constants.ServiceActionCode.PROCESS_OFFLINE_EVENT:var F={};var x=ServiceFactory.getRequestFactory().createProcessOfflineEventRequest(t.getParams()["jsonEvent"]);ServiceFactory.getRequestRouter().handleRequest(x).always(function(R){P.resolve(i(R))});break;case constants.ServiceActionCode.REQUEST_ACHIEVEMENT:var I=ServiceFactory.getRequestFactory().createGetAchievementRequest(t.getParams()["ACHIEVEMENT_ID"],false);var H=ServiceFactory.getRequestRouter().handleRequest(I);H.done(function(R){P.resolve(h(R))});break;case constants.ServiceActionCode.REQUEST_ACHIEVEMENTS:var L=ServiceFactory.getRequestFactory().createGetAchievementsRequest(false);var H=ServiceFactory.getRequestRouter().handleRequest(L);H.done(function(R){P.resolve(a(R))});break;case constants.ServiceActionCode.UPDATE_ACHIEVEMENT_PROGRESS:var w=ServiceFactory.getRequestFactory().createUpdateAchievementsRequest(t.getParams()["ACHIEVEMENT_ID"],t.getParams()["ACHIEVEMENT_UPDATE_PERCENT"]);var H=ServiceFactory.getRequestRouter().handleRequest(w);H.done(function(R){P.resolve(e(R))});break;case constants.ServiceActionCode.REQUEST_LEADERBOARDS:var y=ServiceFactory.getRequestFactory().createGetLeaderboardsForGameRequest(t.getParams()["GAME_ID"],false);var H=ServiceFactory.getRequestRouter().handleRequest(y);H.done(function(R){P.resolve(j(R))});break;case constants.ServiceActionCode.REQUEST_PLAYER_SCORE:var r=ServiceFactory.getRequestFactory().createGetHighScoreRequest(t.getParams()["GAME_ID"],t.getParams()["LEADERBOARD_ID"],t.getParams()["LEADERBOARD_FILTER"],false);var H=ServiceFactory.getRequestRouter().handleRequest(r);H.done(function(R){P.resolve(d(R))});break;case constants.ServiceActionCode.REQUEST_SCORES:t.getParams()["LEADERBOARD_START_RANK"]=1;t.getParams()["LEADERBOARD_SCORES_COUNT"]=100;var B=ServiceFactory.getRequestFactory().createGetLeaderboardRanksRequest(t.getParams()["GAME_ID"],t.getParams()["LEADERBOARD_ID"],t.getParams()["LEADERBOARD_FILTER"],t.getParams()["LEADERBOARD_START_RANK"],t.getParams()["LEADERBOARD_SCORES_COUNT"],false,false);var H=ServiceFactory.getRequestRouter().handleRequest(B);H.done(function(R){P.resolve(f(R,t.getParams()["LEADERBOARD_START_RANK"]))});break;case constants.ServiceActionCode.REQUEST_PERCENTILES:var A=ServiceFactory.getRequestFactory().createGetLeaderboardPercentilesRequest(t.getParams()["GAME_ID"],t.getParams()["LEADERBOARD_ID"],t.getParams()["LEADERBOARD_FILTER"],false,false);var H=ServiceFactory.getRequestRouter().handleRequest(A);H.done(function(R){P.resolve(g(R))});break;case constants.ServiceActionCode.SUBMIT_SCORE:var G=ServiceFactory.getRequestFactory().createSubmitScoreRequest(t.getParams()["LEADERBOARD_ID"],t.getParams()["LEADERBOARD_SUBMIT_SCORE"]);var H=ServiceFactory.getRequestRouter().handleRequest(G);H.done(function(R){P.resolve(b(R,t.getParams()["LEADERBOARD_SUBMIT_SCORE"]))});break;case constants.ServiceActionCode.REQUEST_LOCAL_PLAYER_PROFILE:var K=ServiceFactory.getGCSettings().getGuestMode();K.always(function(R){if(R){var S={};S[constants.BindingKeys.REQUEST_ID_KEY]=t.getParams()[constants.BindingKeys.REQUEST_ID_KEY];S[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(S))}else{var U=ServiceFactory.getRequestFactory().createGetProfileRequest(false);var T=ServiceFactory.getRequestRouter().handleRequest(U);T.always(function(V){var X=V.getResultMap();if(X.hidden){var W={};W[constants.BindingKeys.REQUEST_ID_KEY]=t.getParams()[constants.BindingKeys.REQUEST_ID_KEY];W[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(W))}else{var W={};W[constants.BindingKeys.REQUEST_ID_KEY]=t.getParams()[constants.BindingKeys.REQUEST_ID_KEY];W[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_SUCCESS;W[constants.ProfilesBindingKeys.ALIAS_KEY]=X.alias;W[constants.ProfilesBindingKeys.PLAYER_ID_KEY]=X.playerId;hostinterface.sendReply(JSON.stringify(W))}})}});break;default:console.log("Message not supported what="+v);console.log("APICallHandler: handleRequest: actionCode not supported");var E=new Result(constants.NativeCallResultCode.ERROR,{});P.resolve(E)}}console.log("End of API handler call");return P.promise()}};var i=function(k){var l={};var m=constants.NativeCallResultCode.ERROR;if(k instanceof Result){m=k.getType()}var n=new Result(m,l);return n};var a=function(k){var m={};var p=constants.NativeCallResultCode.ERROR;if(k instanceof Result){p=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){p=constants.NativeCallResultCode.SUCCESS;var l=[];var o=k.getResultMap()["achievements"];var n=o.achievements;$.each(n,function(s,t){var r={};var u=t.achievementMeta;var v=t.playerInfo;r.ACHIEVEMENT_ID=u.id;r.ACHIEVEMENT_TITLE=u.title;r.ACHIEVEMENT_DESCRIPTION=u.description;r.ACHIEVEMENT_POINTS=u.pointValue;r.ACHIEVEMENT_HIDDEN=u.hiddenValue;r.ACHIEVEMENT_UNLOCKED=v.unlocked;r.ACHIEVEMENT_UPDATE_PERCENT=v.progress;r.ACHIEVEMENT_POSITION=u.position;if(r.ACHIEVEMENT_UNLOCKED){r.ACHIEVEMENT_DATE_UNLOCKED=v.dateUnlocked;r.ACHIEVEMENT_ICON_URL_LARGE=u.largeIconUrl}else{r.ACHIEVEMENT_DATE_UNLOCKED=0;r.ACHIEVEMENT_ICON_URL_LARGE=u.lockedLargeIconUrl}l.push(r)});m[constants.AchievementsBindingKeys.ACHIEVEMENT_LIST_KEY]=l}}var q=new Result(p,m);return q};var h=function(k){var m={};var o=constants.NativeCallResultCode.ERROR;if(k instanceof Result){o=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){o=constants.NativeCallResultCode.SUCCESS;var n=k.getResultMap()["achievement"];var l=n.achievementMeta;var q=n.playerInfo;m[constants.AchievementsBindingKeys.ACHIEVEMENT_ID_KEY]=l.id;m[constants.AchievementsBindingKeys.ACHIEVEMENT_TITLE_KEY]=l.title;m[constants.AchievementsBindingKeys.ACHIEVEMENT_DESCRIPTION_KEY]=l.description;m[constants.AchievementsBindingKeys.ACHIEVEMENT_POINTS_KEY]=l.pointValue;m[constants.AchievementsBindingKeys.ACHIEVEMENT_HIDDEN_KEY]=l.hiddenValue;m[constants.AchievementsBindingKeys.ACHIEVEMENT_POSITION_KEY]=l.position;m[constants.AchievementsBindingKeys.ACHIEVEMENT_ICON_URL_LARGE_KEY]=l.lockedLargeIconUrl;if(q!=null){m[constants.AchievementsBindingKeys.ACHIEVEMENT_UNLOCKED_KEY]=q.unlocked;m[constants.AchievementsBindingKeys.ACHIEVEMENT_UPDATE_PERCENT_KEY]=q.progress;if(m[constants.AchievementsBindingKeys.ACHIEVEMENT_UNLOCKED_KEY]){m[constants.AchievementsBindingKeys.ACHIEVEMENT_DATE_UNLOCKED_KEY]=q.dateUnlocked;m[constants.AchievementsBindingKeys.ACHIEVEMENT_ICON_URL_LARGE_KEY]=l.largeIconUrl}else{m[constants.AchievementsBindingKeys.ACHIEVEMENT_DATE_UNLOCKED_KEY]=0}}}}var p=new Result(o,m);return p};var e=function(k){var m={};var n=constants.NativeCallResultCode.ERROR;if(k instanceof Result){n=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){n=constants.NativeCallResultCode.SUCCESS;var l=k.getResultMap()["newlyUnlocked"];m[constants.AchievementsBindingKeys.ACHIEVEMENT_NEWLY_UNLOCKED_KEY]=l}}var o=new Result(n,m);return o};var j=function(l){var n={};var o=constants.NativeCallResultCode.ERROR;if(l instanceof Result){o=l.getType();if(l.getType()==constants.NativeCallResultCode.SUCCESS){o=constants.NativeCallResultCode.SUCCESS;var m=[];var k=l.getResultMap()["LeaderboardList"];$.each(k,function(t,s){var q={};var r=s.LeaderboardInfo;q.LEADERBOARD_ID=r.LeaderboardId;q.LEADERBOARD_NAME=r.Name;q.LEADERBOARD_DISPLAY_TEXT=r.DisplayText;q.LEADERBOARD_DATA_FORMAT=r.DataFormat;q.LEADERBOARD_ICON_URL=r.IconUrl;m.push(q)});n[constants.LeaderboardBindingKeys.LEADERBOARD_LIST_KEY]=m}}var p=new Result(o,n);return p};var d=function(k){var l={};var o=constants.NativeCallResultCode.ERROR;if(k instanceof Result){o=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){o=constants.NativeCallResultCode.SUCCESS;var n=k.getResultMap()["PlayerScore"];var m=k.getResultMap()["PlayerRank"];l[constants.LeaderboardBindingKeys.LEADERBOARD_SUBMIT_SCORE_KEY]=n;l[constants.LeaderboardBindingKeys.LEADERBOARD_PLAYER_RANK_KEY]=m}}var p=new Result(o,l);return p};var f=function(z,r){var o={};var y=constants.NativeCallResultCode.ERROR;if(z instanceof Result){y=z.getType();if(z.getType()==constants.NativeCallResultCode.SUCCESS){y=constants.NativeCallResultCode.SUCCESS;var q=z.getResultMap()["LeaderboardInfo"];var u=z.getResultMap()["RankList"];var n=u.length;var p=q.DisplayText;var t=q.DataFormat;var l=q.Name;var k=q.LeaderboardId;var s=(typeof q.IconUrl==="undefined")?null:q.IconUrl;var w=[];var v=r;var m=[];$.each(u,function(D,C){var E=v;var A=C.Score;var B=C.Username;var F={};F[constants.LeaderboardBindingKeys.LEADERBOARD_SCORE_VALUE_KEY]=A;F[constants.LeaderboardBindingKeys.LEADERBOARD_SCORE_RANK_KEY]=E;F[constants.LeaderboardBindingKeys.LEADERBOARD_KEY]=k;F[constants.ProfilesBindingKeys.ALIAS_KEY]=B;m.push(F);v++});o[constants.LeaderboardBindingKeys.LEADERBOARD_DISPLAY_TEXT_KEY]=p;o[constants.LeaderboardBindingKeys.LEADERBOARD_DATA_FORMAT_KEY]=t;o[constants.LeaderboardBindingKeys.LEADERBOARD_NAME_KEY]=l;o[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=k;o[constants.LeaderboardBindingKeys.LEADERBOARD_SCORES_ARRAY_KEY]=m;o[constants.LeaderboardBindingKeys.LEADERBOARD_ICON_URL_KEY]=s}}var x=new Result(y,o);return x};var g=function(k){var p={};var q=constants.NativeCallResultCode.ERROR;if(k instanceof Result){q=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){q=constants.NativeCallResultCode.SUCCESS;var l=k.getResultMap()["LeaderboardInfo"];var o=k.getResultMap()["UserIndex"];var n=k.getResultMap()["PercentileList"];var m=[];$.each(n,function(u,w){var s=w.Percentile;var t=w.PlayerName;var x=w.PlayerScore;var v={};v.Percentile=s;v.PlayerName=t;v.PlayerScore=x;m.push(v)});p[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=l.LeaderboardId;p[constants.LeaderboardBindingKeys.LEADERBOARD_NAME_KEY]=l.Name;p[constants.LeaderboardBindingKeys.LEADERBOARD_DISPLAY_TEXT_KEY]=l.DisplayText;p[constants.LeaderboardBindingKeys.LEADERBOARD_DATA_FORMAT_KEY]=l.DataFormat;p[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILES_ARRAY_KEY]=m;p[constants.LeaderboardBindingKeys.LEADERBOARD_USER_INDEX_KEY]=o;p[constants.LeaderboardBindingKeys.LEADERBOARD_ICON_URL_KEY]=(typeof l.IconUrl==="undefined")?null:l.IconUrl}}var r=new Result(q,p);return r};var b=function(k,p){var l={};var n=constants.NativeCallResultCode.ERROR;if(k instanceof Result){n=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){n=constants.NativeCallResultCode.SUCCESS;var m=k.getResultMap()["SubmitScoreResultsList"];l[constants.LeaderboardBindingKeys.LEADERBOARD_SUBMIT_RESULT_KEY]=m}}var o=new Result(n,l);return o};return c}());console.log("APICallHandler loaded.");